VERSION 5.00
Begin VB.UserControl OptionGroup 
   ClientHeight    =   405
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   405
   PropertyPages   =   "OptionGroup.ctx":0000
   ScaleHeight     =   405
   ScaleWidth      =   405
   ToolboxBitmap   =   "OptionGroup.ctx":001A
   Begin VB.Frame Frame1 
      Height          =   495
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   -90
      Width           =   405
      Begin VB.OptionButton Option1 
         Height          =   195
         Index           =   0
         Left            =   90
         TabIndex        =   1
         Top             =   195
         Width           =   195
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   ""
      Begin VB.Menu mnuReset 
         Caption         =   "Reset"
      End
   End
End
Attribute VB_Name = "OptionGroup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit
'*******************************************************************
'         Option Group Control
' Author: Martin A. Kremer
' Copyright: 2002-11-01
' This control was designed to simplify creation of forms for
' multiple-choice type data entry.
'
' Contact the author at makremer@ameritech.net
'*******************************************************************


'Default Property Values:
Const m_def_Orientation = 0
Const m_def_InterOptionSpacing = 400
Const m_def_AllowUserReset = True
Const m_def_Value = -999
Const m_def_Enabled = True
Const m_def_BackStyle = 0
Const m_def_OptionCount = 1
Const m_def_LowEndValue = 0
Const m_def_NoSelectionValue = -999
Const m_def_LeftOrTopIsLow = True
Const m_def_InternalUpdate = False
'Property Variables:
Dim m_Orientation As Integer
Dim m_InterOptionSpacing As Integer
Dim m_AllowUserReset As Boolean
Dim m_Value As Integer
Dim m_Enabled As Boolean
Dim m_BackStyle As Integer
Dim m_OptionCount As Integer
Dim m_LowEndValue As Integer
Dim m_NoSelectionValue As Integer
Dim m_LeftOrTopIsLow As Boolean
Dim m_InternalUpdate As Boolean
'Event Declarations:
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

' Constants for this control
Public Enum OrientationConstants
    opgHorizontal = 0
    opgVertical
End Enum
Const m_def_FrameWidth = 305
Const m_def_FrameHeight = 495
Const m_def_OptionWidth = 195
Const m_def_OptionHeight = 195
Const m_def_UserCtlScaleWidth = 465
Const m_def_UserCtlScaleHeight = 465
Const m_FrameToOptLeft = 90
Const m_FrameToOptTop = -90

'Error Constants
Public Enum OptGrpErr
    opgerrbase = vbObjectError + 1001
    opgOptionCountError = opgerrbase
End Enum
' Error Message Constants
Const opgAssignValueErrmsg = " Attempt to assign invalid value: "




    


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    Frame1(0).BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    
    Dim i As Integer
    For i = 0 To Option1.Count - 1
        Option1(i).Enabled = New_Enabled
    Next i
    
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = m_BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    m_BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
     
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,1,0,1
Public Property Get OptionCount() As Integer
Attribute OptionCount.VB_ProcData.VB_Invoke_Property = "OptionsPropertyPage"
    OptionCount = m_OptionCount
End Property

Public Property Let OptionCount(ByVal New_OptionCount As Integer)
    
    'Option count can range from 1 thru 7 only
    ' This represents the normal maximum range of Likert scale responses
    If New_OptionCount < 1 Or New_OptionCount > 7 Then
        If Ambient.UserMode Then
            Err.Raise opgOptionCountError, "OptionCount Assignment", _
                      opgAssignValueErrmsg & _
                      New_OptionCount & " OptionCount must be 1 through 7"
        Else
            MsgBox "Error " & opgOptionCountError & ": " & opgAssignValueErrmsg & _
                    New_OptionCount & vbCrLf & _
                    " OptionCount must be 1 through 7"
            Exit Property
        End If
    End If
        
    'Check for inconsistent value combinations
    If Not CrossCheck(NoSelectionValue, New_OptionCount, LowEndValue) Then
        Exit Property
    End If
    InternalUpdate = True
    m_OptionCount = New_OptionCount
    Frame1(0).Width = ((Option1(0).Width + InterOptionSpacing) * New_OptionCount) - (InterOptionSpacing / 2)
    Frame1(0).Refresh
    UserControl.Width = Frame1(0).Width

    
    
    InternalUpdate = False
    AdjustControl
    PropertyChanged "OptionCount"
End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=7,1,2,-999
Public Property Get value() As Integer
Attribute value.VB_UserMemId = 0
Attribute value.VB_MemberFlags = "400"
    Dim i As Integer
    Dim answer As Integer
    answer = NoSelectionValue
    For i = 0 To Option1.Count - 1
        If Option1(i) Then
            answer = i
        End If
    Next i
        If answer = NoSelectionValue Then
        value = answer
        Exit Property
    End If
    If Me.LeftOrTopIsLow Then
        value = answer + Me.LowEndValue
    Else
        value = OptionCount - 1 + Me.LowEndValue - answer
    End If

End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,1,0,0
Public Property Get LowEndValue() As Integer
Attribute LowEndValue.VB_ProcData.VB_Invoke_Property = "OptionsPropertyPage"
    LowEndValue = m_LowEndValue
End Property

Public Property Let LowEndValue(ByVal New_LowEndValue As Integer)
    If Ambient.UserMode Then Err.Raise 382
    If Not CrossCheck(NoSelectionValue, OptionCount, New_LowEndValue) Then
        Exit Property
    End If
    
    m_LowEndValue = New_LowEndValue
    PropertyChanged "LowEndValue"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,-999
Public Property Get NoSelectionValue() As Integer
Attribute NoSelectionValue.VB_ProcData.VB_Invoke_Property = "OptionsPropertyPage"
    NoSelectionValue = m_NoSelectionValue
End Property

Public Property Let NoSelectionValue(ByVal New_NoSelectionValue As Integer)
    ' The value to be returned by the Value property if no option button
    ' is selected
     If Not CrossCheck(New_NoSelectionValue, OptionCount, LowEndValue) Then
         Exit Property
     End If
    
    m_NoSelectionValue = New_NoSelectionValue
    PropertyChanged "NoSelectionValue"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,1,0,true
Public Property Get LeftOrTopIsLow() As Boolean
Attribute LeftOrTopIsLow.VB_ProcData.VB_Invoke_Property = "OptionsPropertyPage"
    LeftOrTopIsLow = m_LeftOrTopIsLow
End Property

Public Property Let LeftOrTopIsLow(ByVal New_LeftOrTopIsLow As Boolean)
    If Ambient.UserMode Then Err.Raise 382
    m_LeftOrTopIsLow = New_LeftOrTopIsLow
    PropertyChanged "LeftOrTopIsLow"
End Property

Private Sub Frame1_MouseUp(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   
    Call UserControl_MouseUp(Button, Shift, X, Y)
End Sub

Private Sub mnuReset_Click()
        Reset

End Sub

Private Sub Option1_Click(index As Integer)
    RaiseEvent Click
End Sub

Private Sub Option1_MouseUp(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    If Button = vbRightButton Then
        Call UserControl_MouseUp(Button, Shift, X, Y)
    End If
End Sub




'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Enabled = m_def_Enabled
    m_BackStyle = m_def_BackStyle
    m_OptionCount = m_def_OptionCount
    m_LowEndValue = m_def_LowEndValue
    m_NoSelectionValue = m_def_NoSelectionValue
    m_LeftOrTopIsLow = m_def_LeftOrTopIsLow
    m_Value = m_def_Value
    m_InternalUpdate = m_def_InternalUpdate
    m_Orientation = m_def_Orientation
    m_InterOptionSpacing = m_def_InterOptionSpacing
    m_AllowUserReset = m_def_AllowUserReset
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'suppress menu if user is not allowed to reset the control to "No Selection"
    If Ambient.UserMode And Not AllowUserReset Then Exit Sub
    'suppress menu if no item has been selected
    If Me.value = Me.NoSelectionValue Then Exit Sub
    If Button = vbRightButton Then
        PopupMenu mnuPopup
    End If
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    m_BackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_OptionCount = PropBag.ReadProperty("OptionCount", m_def_OptionCount)
    m_LowEndValue = PropBag.ReadProperty("LowEndValue", m_def_LowEndValue)
    m_NoSelectionValue = PropBag.ReadProperty("NoSelectionValue", m_def_NoSelectionValue)
    m_LeftOrTopIsLow = PropBag.ReadProperty("LeftOrTopIsLow", m_def_LeftOrTopIsLow)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    m_InternalUpdate = PropBag.ReadProperty("InternalUpdate", m_def_InternalUpdate)
    m_Orientation = PropBag.ReadProperty("Orientation", m_def_Orientation)
    m_InterOptionSpacing = PropBag.ReadProperty("InterOptionSpacing", m_def_InterOptionSpacing)
    m_AllowUserReset = PropBag.ReadProperty("AllowUserReset", m_def_AllowUserReset)
    Option1(0).Appearance = PropBag.ReadProperty("Appearance", 1)
End Sub

Private Sub UserControl_Resize()
    If InternalUpdate Then Exit Sub
    Dim h As Integer
    Dim w As Integer
    Dim divisor As Integer
    
    h = UserControl.Height
    w = UserControl.Width - (m_FrameToOptLeft * 2)
    w = w - m_def_OptionWidth * OptionCount
    divisor = OptionCount + (OptionCount > 1)
    If OptionCount > 1 Then
        InterOptionSpacing = w / divisor
    End If
End Sub

Private Sub UserControl_Show()
    'If Ambient.UserMode = False Then Exit Sub
    Dim optWidth As Integer
    Dim i As Integer
    AdjustControl
    Reset

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("BackStyle", m_BackStyle, m_def_BackStyle)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("OptionCount", m_OptionCount, m_def_OptionCount)
    Call PropBag.WriteProperty("LowEndValue", m_LowEndValue, m_def_LowEndValue)
    Call PropBag.WriteProperty("NoSelectionValue", m_NoSelectionValue, m_def_NoSelectionValue)
    Call PropBag.WriteProperty("LeftOrTopIsLow", m_LeftOrTopIsLow, m_def_LeftOrTopIsLow)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("InternalUpdate", m_InternalUpdate, m_def_InternalUpdate)
    Call PropBag.WriteProperty("Orientation", m_Orientation, m_def_Orientation)
    Call PropBag.WriteProperty("InterOptionSpacing", m_InterOptionSpacing, m_def_InterOptionSpacing)
    Call PropBag.WriteProperty("AllowUserReset", m_AllowUserReset, m_def_AllowUserReset)
    Call PropBag.WriteProperty("Appearance", Option1(0).Appearance, 1)
End Sub

Private Function CrossCheck(NSV As Integer, OptCnt As Integer, LowVal As Integer) As Boolean
   Dim msgtxt As String
   CrossCheck = True
   
   If NSV >= LowVal And NSV <= OptCnt + LowVal - 1 Then
        MsgBox "Not Selected value: " & NSV & vbCrLf & "OptionCount: " & OptCnt & vbCrLf & "Lowest Value: " & LowVal & vbCrLf & "This combination of values is invalid"
        CrossCheck = False
   End If
 
    
    
End Function

Public Sub Reset()
    
    Dim i As Integer
     For i = 0 To Option1.Count - 1
        Option1(i).value = False
    Next i
    RaiseEvent Click
End Sub

Private Property Get InternalUpdate() As Boolean
    InternalUpdate = m_InternalUpdate
End Property
Private Property Let InternalUpdate(ByVal newValue As Boolean)
    m_InternalUpdate = newValue
End Property
Private Sub AdjustControl()
Dim i As Integer
    
    UserControl.Width = (m_FrameToOptLeft * 2) + (InterOptionSpacing * (OptionCount - 1)) + (m_def_OptionWidth * OptionCount)
    Frame1(0).Width = UserControl.Width
    
    Option1(0).Enabled = Me.Enabled
    If OptionCount > Option1.Count Then
        For i = Option1.Count To OptionCount - 1
            Load Option1(i)
            Option1(i).Left = Option1(i - 1).Left _
                              + m_def_OptionWidth _
                              + InterOptionSpacing
            Option1(i).Visible = True
            Option1(i).Enabled = Me.Enabled
        Next i
    End If
    If OptionCount < Option1.Count Then
        If Ambient.UserMode = True Then
            For i = Option1.Count - 1 To OptionCount Step -1
                Unload Option1(i)
            Next i
        End If
    End If

End Sub

Public Property Let value(ByVal new_value As Integer)
    If Not Ambient.UserMode Then Exit Property
    If new_value = Me.NoSelectionValue Then
        Reset
        Exit Property
    End If
    
    Dim answer As Integer
    answer = new_value
    Dim index As Integer
    If Me.LeftOrTopIsLow Then
        answer = answer - Me.LowEndValue
    Else
        answer = OptionCount - 1 + Me.LowEndValue - answer
    End If
    index = answer
    If index < 0 Or index > Option1.Count - 1 Then Exit Property
    Option1(index).value = True
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,3,2,0
Public Property Get Orientation() As Integer
Attribute Orientation.VB_MemberFlags = "400"
    If Ambient.UserMode Then Err.Raise 393
    Orientation = m_Orientation
End Property

Public Property Let Orientation(ByVal New_Orientation As Integer)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    'm_Orientation = New_Orientation
    PropertyChanged "Orientation"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,400
Private Property Get InterOptionSpacing() As Integer
    InterOptionSpacing = m_InterOptionSpacing
End Property

Private Property Let InterOptionSpacing(ByVal New_InterOptionSpacing As Integer)
    m_InterOptionSpacing = New_InterOptionSpacing
    PropertyChanged "InterOptionSpacing"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,true
Public Property Get AllowUserReset() As Boolean
    AllowUserReset = m_AllowUserReset
End Property

Public Property Let AllowUserReset(ByVal New_AllowUserReset As Boolean)
    m_AllowUserReset = New_AllowUserReset
    PropertyChanged "AllowUserReset"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Option1(0),Option1,0,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = Option1(0).Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    Dim i As Integer
    For i = 0 To Option1.Count - 1
        Option1(i).Appearance() = New_Appearance
        Option1(i).BackColor = UserControl.BackColor
    Next i
    For i = 0 To Frame1.Count - 1
        Frame1(i).Appearance = New_Appearance
        Frame1(i).BackColor = UserControl.BackColor
    Next i
    PropertyChanged "Appearance"
End Property

